Subject: Re: bug#27490: 24.5; Elisp manual explanation of `function-key-map' and its inheritors

From: Eli Zaretskii <[email-masked]>
Date: Sun, 21 Jul 2019 19:39:49 +0300

> From: Lars Ingebrigtsen <[email-masked]>
> Date: Sun, 21 Jul 2019 17:33:45 +0200
> Cc: [email-masked]
> 
> This text:
> 
> ------
> 
> @code{local-function-key-map} inherits from @code{function-key-map},
> but the latter should not be used directly.
> 
> ------
> 
> was added by this commit:
> 
> ------
> 
> commit 6b9e769476955b928b0248fef5aaa0e40754e257
> Author: Eli Zaretskii <[email-masked]>
> Date:   Sat Jan 17 19:14:52 2009 +0000
> 
>     (Translation Keymaps): Rename function-key-map to local-function-key-map.
> 
> ------
> 
> 
> So I'm assuming that there was a plan to phase out using
> function-key-map or something?  Perhaps Eli can clarify.

I don't remember any details, and I found no discussions of this
around that date.  However, you will find a bunch of commits around
that one which all renamed function-key-map to
local-function-key-map.  So yes, it appears like we wanted people to
use the latter.

> But there's a bunch of examples in the manual that does use the map, so
> either these should be adjusted, or the documentation clarified:

I think the examples which use function-key-map should be modified,
yes.

> The only way to affect the behavior of keys within Emacs is through
> @code{xmodmap} (outside Emacs) or @code{define-key} (inside Emacs).  The
> @code{define-key} command should be used in conjunction with the
> @code{function-key-map} map.  For instance,
> 
> @lisp
> (define-key function-key-map [M-@key{TAB}] [?\M-\t])
> @end lisp

Where did you find this?  I must be blind, because I don't see this
passage in the manual.